# BEGIN SourceDeps(oneline):
BuildRequires: gcc-c++
# END SourceDeps(oneline)
%add_findprov_skiplist %_libdir/swipl-*
%add_findreq_skiplist %_libdir/swipl-*
%define with_java 1
%define separate_xpce 1

Name:       pl
Version:    6.2.4
Release:    alt1_1

Summary:    SWI-Prolog - Edinburgh compatible Prolog compiler

Group:      Development/Other
#library/dialect/iso/iso_predicates.pl  GPLv2+ with SWI-Prolog extra clause
#                                       or Artistic 2.0
#packages/clib/uri.c            LGPLv2+
#packages/sgml/Test/test.pl     LGPLv2
#library/qsave.pl               GPLv2+
#library/COPYING                GPLv2 with SWI-Prolog extra clause
#library/unicode/blocks.pl      UCD
#packages/http/examples/calc.pl Public Domain
#External: JavaConfig.java      GPLv3+
License:    (GPLv2+ or Artistic 2.0) and LGPLv2+ and LGPLv2 and GPLv2 and GPLv2+ and UCD and Public Domain and GPLv3+
URL:        http://www.swi-prolog.org/
Source:     %{url}download/stable/src/%{name}-%{version}.tar.gz
Source1:    %{url}download/stable/doc/SWI-Prolog-%{version}.pdf
Source2:    %{url}download/xpce/doc/userguide/userguide.html.tgz
Source3:    JavaConfig.java
Patch1:     %{name}-6.2.2-jpl-configure.patch
Patch2:     %{name}-5.10.5-man-files.patch
Patch3:     %{name}-6.0.2-jni.patch
Patch4:     %{name}-6.2.0-pc.patch

# Base
BuildRequires:  libgmp-devel libgmp_cxx-devel
BuildRequires:  ncurses-devel
BuildRequires:  readline-devel
# XPCE
BuildRequires:  libICE-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libSM-devel
BuildRequires:  libX11-devel
BuildRequires:  libXft-devel
BuildRequires:  libXinerama-devel
BuildRequires:  libXpm-devel
BuildRequires:  libXt-devel
# Freetype support in XPCE
BuildRequires:  fontconfig-devel
BuildRequires:  libfreetype-devel
BuildRequires:  libXaw-devel
BuildRequires:  libXext-devel
BuildRequires:  libXmu-devel
BuildRequires:  libXrender-devel
# ODBC
BuildRequires:  libunixODBC-devel
# SSL
BuildRequires:  libssl-devel
# jpl
%if %{with_java}
BuildRequires:  jpackage-utils
BuildRequires:  java-devel
%endif
# zlib
BuildRequires:  zlib-devel
# helpers for export_dynamic patch
BuildRequires:  autoconf
Source44: import.info

%description
ISO/Edinburgh-style Prolog compiler including modules, auto-load,
libraries, Garbage-collector, stack-expandor, C/C++-interface,
GNU-readline interface, very fast compiler.  Including packages clib
(Unix process control and sockets), cpp (C++ interface), sgml (reading
XML/SGML), sgml/RDF (reading RDF into triples) and XPCE (Graphics UI
toolkit, integrated editor (Emacs-clone) and source-level debugger).


%package devel
Summary: Development files for SWI Prolog
Group: Development/Other
Requires: %{name} = %{version}-%{release}

%description devel
Development files for SWI Prolog.


%package compat-yap-devel
Summary: Development files building YAP application against SWI Prolog
Group: Development/Other
License: GPLv2+

%description compat-yap-devel
This package allows to build Yet Annother Prolog applications against SWI
Prolog implementation.


%package doc
Summary: Documentation for SWI Prolog
Group: Documentation
# This must be archicture dependend because some files live in %%{_libdir}
# because they are used by built-in documentation system.
Requires: %{name} = %{version}-%{release}

%description doc
%%{summary}.


%package odbc
Summary: SWI-Prolog ODBC interface
Group: Development/Other
Requires: %{name} = %{version}-%{release}

%description odbc
The value of RDMS for Prolog is often over-estimated, as Prolog itself can
manage substantial amounts of data. Nevertheless a Prolog/RDMS interface
provides advantages if data is already provided in an RDMS, data must be
shared with other applications, there are strong persistency requirements
or there is too much data to fit in memory.                                  
                                                                            
The popularity of ODBC makes it possible to design a single
foreign-language module that provides RDMS access for a wide variety of
databases on a wide variety of platforms. The SWI-Prolog RDMS interface is
closely modeled after the ODBC API. This API is rather low-level, but
defaults and dynamic typing provided by Prolog give the user quite simple
access to RDMS, while the interface provides the best possible performance
given the RDMS independency constraint.   


%package static
Summary: Static library for SWI Prolog
Group: Development/Other
Requires: %{name} = %{version}-%{release}

%description static
Static library for SWI Prolog.


%if %{separate_xpce}
%package xpce
Summary: A toolkit for developing graphical applications in Prolog
Group: Development/Other
Requires: %{name} = %{version}-%{release}

%description xpce
XPCE is a toolkit for developing graphical applications in Prolog and other
interactive and dynamically typed languages. XPCE follows a rather unique
approach of for developing GUI applications, as follows:

- Add object layer to Prolog
- High level of abstraction
- Exploit rapid Prolog development cycle
- Platform independent programs
%endif


%if %{with_java}
%package jpl
Summary: A bidirectional Prolog/Java interface for SWI Prolog
Group: Development/Other
Requires: %{name} = %{version}-%{release}
Requires: java
Requires: jpackage-utils

%description jpl
JPL is a library using the SWI-Prolog foreign interface and the Java Native
Interface providing a bidirectional interface between Java and Prolog
that can be used to embed Prolog in Java as well as for embedding Java
in Prolog. In both setups it provides a re-entrant bidirectional interface.
%endif


%prep
%global docdir doc-install
%setup -q
%patch1 -p1 -b .libjvm
%patch2 -p1 -b .man-files
%patch3 -p1 -b .jni
%patch4 -p1 -b .pc
(
   cd src
   autoconf
)
(
   mkdir %{docdir}
   cp -p %{SOURCE1} %{docdir}
)
(
   mkdir %{docdir}-xpce
   cd %{docdir}-xpce
   tar -xzf %{SOURCE2}
   mv UserGuide xpce-UserGuide
)
(
    cp %{SOURCE3} .
)

# Adjustments to take into account the new location of JNI stuff
sed --in-place=.jni2 -e 's#LIBDIR#%{_libdir}#g' packages/jpl/jpl.pl
sed --in-place=.jni2 -e 's#LIBDIR#%{_libdir}#g' packages/jpl/src/java/jpl/fli/Prolog.java
sed --in-place=.jni2 -e 's#LIBDIR#"%{_libdir}/swipl-jpl"#g' packages/jpl/src/java/jpl/JPL.java


%build
%if %{with_java}
LC_CTYPE=en_US.UTF-8 javac JavaConfig.java
JAVA_HOME=$(java JavaConfig --home)
JAVA_LIBS=$(java JavaConfig --libs-only-L)
%else
# Processed by packages/configure
export DISABLE_PKGS="jpl"
%endif

# Build interpreter needed for SWI packages compilation
%configure --enable-shared LDFLAGS="-Wl,--enable-new-dtags"
make COFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"

# Build SWI packages
pushd packages
%configure LDFLAGS="-Wl,--enable-new-dtags"
make COFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" JAVALIBS="${JAVA_LIBS} -ljava -lverify -ljvm"
popd


%install
# See <http://www.swi-prolog.org/build/guidelines.html> for file layout
make install DESTDIR=$RPM_BUILD_ROOT
# Library must be executable to get its debuginfo
chmod 0755 $RPM_BUILD_ROOT%{_libdir}/swipl-%{version}/lib/*/libswipl.so.*
# Script with shebang should be executable
chmod 0755 \
$RPM_BUILD_ROOT%{_libdir}/swipl-%{version}/library/dialect/sicstus/swipl-lfr.pl

pushd packages
make install DESTDIR=$RPM_BUILD_ROOT
# Do not chmod earlier, the run.sh's are executed
chmod -x jpl/examples/java/*/run.sh
popd

%if %{with_java}
# Move the JPL JNI stuff to where the Java packaging guidelines 
# say it should be
pushd $RPM_BUILD_ROOT%{_libdir}
mkdir -p swipl-jpl
mv swipl-%{version}/lib/*/libjpl.so swipl-jpl/
mv swipl-%{version}/lib/jpl.jar swipl-jpl/
# Original JAR locations is referenced by internal libraries and examples
ln -s ../../swipl-jpl/jpl.jar swipl-%{version}/lib/jpl.jar
popd
%endif

# Clean up the other stuff that shouldn't be packaged
find packages/jpl/examples -name "*.class" | xargs rm -f
find packages/jpl/examples -name ".cvsignore" | xargs rm -f


%files
%doc ReleaseNotes/relnotes-5.10 README COPYING VERSION
%doc customize/dotplrc
%{_mandir}/man1/*
%dir %{_libdir}/swipl-%{version}
%{_libdir}/swipl-%{version}/*
%{_bindir}/*

# Exclude the files that are in the sub-packages
%if %{with_java}
# JPL
%exclude %{_libdir}/swipl-%{version}/lib/jpl.jar
%exclude %{_libdir}/swipl-%{version}/library/jpl.pl
%endif
# Devel
%exclude %{_libdir}/swipl-%{version}/lib/*/libswipl.so
%exclude %{_libdir}/swipl-%{version}/include
# Doc
%exclude %{_libdir}/swipl-%{version}/doc
# ODBC
%exclude %{_libdir}/swipl-%{version}/lib/*-linux/odbc4pl.so
%exclude %{_libdir}/swipl-%{version}/library/odbc.pl
# Static
%exclude %{_libdir}/swipl-%{version}/lib/*/libswipl.a
%if %{separate_xpce}
# XPCE
%exclude %{_bindir}/xpce*
%exclude %{_libdir}/swipl-%{version}/customize/dotxpcerc
%exclude %{_libdir}/swipl-%{version}/lib/*-linux/pl2xpce.so
%exclude %{_libdir}/swipl-%{version}/library/http/xpce_httpd.pl
%exclude %{_libdir}/swipl-%{version}/Makefile
%exclude %{_libdir}/swipl-%{version}/swipl.rc
%exclude %{_libdir}/swipl-%{version}/xpce
%exclude %{_mandir}/man1/xpce-client.1*
%endif

%if %{separate_xpce}
%files xpce
%doc customize/dotxpcerc packages/xpce/INFO
%{_bindir}/xpce*
%{_libdir}/swipl-%{version}/customize/dotxpcerc
%{_libdir}/swipl-%{version}/lib/*-linux/pl2xpce.so
%{_libdir}/swipl-%{version}/library/http/xpce_httpd.pl
%{_libdir}/swipl-%{version}/Makefile
%{_libdir}/swipl-%{version}/swipl.rc
%{_libdir}/swipl-%{version}/xpce
%{_mandir}/man1/xpce-client.1*
%endif

%files devel
%{_libdir}/swipl-%{version}/include
%exclude %{_libdir}/swipl-%{version}/include/Yap
%{_libdir}/swipl-%{version}/lib/*/libswipl.so
%{_libdir}/pkgconfig/swipl.pc

%files compat-yap-devel
%{_libdir}/swipl-%{version}/include/Yap

%files doc
%{_libdir}/swipl-%{version}/doc
%doc %{docdir}/*
%doc %{docdir}-xpce/*

%files odbc
%{_libdir}/swipl-%{version}/lib/*-linux/odbc4pl.so
%{_libdir}/swipl-%{version}/library/odbc.pl
%doc packages/odbc/{demo,ChangeLog,odbc.html,README}

%files static
%{_libdir}/swipl-%{version}/lib/*/libswipl.a

%if %{with_java}
%files jpl
%doc packages/jpl/docs/*
%doc packages/jpl/examples
%{_libdir}/swipl-%{version}/lib/jpl.jar
%{_libdir}/swipl-%{version}/library/jpl.pl
%{_libdir}/swipl-jpl
%endif


%changelog
* Fri Dec 21 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.4-alt1_1
- update to new release by fcimport

* Tue Dec 04 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.3-alt1_2
- update to new release by fcimport

* Sun Nov 25 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.3-alt1_1
- update to new release by fcimport

* Tue Oct 09 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.2-alt1_1
- update to new release by fcimport

* Mon Sep 17 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.1-alt1_1
- update to new release by fcimport

* Mon Aug 27 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.0-alt1_1
- update to new release by fcimport

* Thu Aug 02 2012 Igor Vlasenko <viy@altlinux.ru> 6.0.2-alt1_4
- update to new release by fcimport

* Tue Jun 05 2012 Igor Vlasenko <viy@altlinux.ru> 6.0.2-alt1_3
- fc import

